#ifndef __MAP__
#define __MAP__

class OrientedPose
{
 public:
  OrientedPose(float x=0, float y=0, float t=0) : x(x), y(y), t(t) {}
  
  OrientedPose& operator= (const OrientedPose& p) { x = p.x; y=p.y; t=p.t; return (*this); } 
 
  float x;
  float y;
  float t;
};

class Map
{

public:
  Map(int xSize = 0, int ySize = 0);
  ~Map();
  Map(const Map& m);
  
  Map&   operator=  (const Map& m);
  float& operator() (int x, int y);
  float  operator() (int x, int y) const;
  float& operator() (float x, float y);
  float  operator() (float x, float y) const;

  Map&   operator-= (const Map& m);
  Map&   operator*= (const Map& m);
  
  void resize      (int xSize, int ySize);
  
  void growCircle  (int r );
  void growSquare  (int hl);
  
  void doThreshold (float v);
  void doNormalize ();
  
  float getMaxVal  ();
  
  int    xSize;
  int    ySize;
  float* data;

};

#endif
