#include "RobotController.h"

void RobotController::initializeCameras()
{
  dc1394error_t   cur_status;
  
  cams=new CamClass();
  
  cur_status=cams->init();	
  if ( cur_status != DC1394_SUCCESS )
    {
      cerr << "CamClass: Could not initialize all cameras" << endl;
      cams->cleanup();
      return ;
    }
  cout << "CamClass: Initialized cameras" << endl;
  cams->cleanup();
  cur_status=cams->init();	
  cur_status=cams->setAllCameraRegisters(100000);
  if ( cur_status != DC1394_SUCCESS )
    {
      cerr << "CamClass: Could not set ALL cameras registers" << endl;
      cams->cleanup();
      return ;
    }
  cout << "CamClass: Set registers" << endl;
  
  cout << "CamClass: Ready to capture data" << endl;
  
}

void RobotController::triggerCameras()
{
  dc1394error_t   cur_status;

  cur_status=cams->triggerAllCameras();
  if ( cur_status != DC1394_SUCCESS )
    {
      cerr << "CamClass: Could not trigger ALL cameras registers" << endl;
      cams->cleanup();
      return ;
    }
  cout << "CamClass: Triggered cameras" << endl;
}

