#include <fstream>
#include <iostream>
using namespace std;

#include "RobotController.h"


int RobotController::readSLAMData()
{
  readOccupancyGridFromFile("occupancy.dat");
  readRobotPoseFromFile    ("pose.dat");

  return 1;
}


int RobotController::readOccupancyGridFromFile(string fileName)
{
  ifstream  fin(fileName.c_str());

  if (!fin)
    {
      cout << "Could not read occupancy grid from file:" << fileName << endl;
      return 0;
    }

  int    mapSizeX,   mapSizeY;
  double worldSizeX, worldSizeY;//, delta;

  fin >> mapSizeY >> mapSizeX >> worldSizeY >> worldSizeX >> mpres;

  slamMap.resize(mapSizeX, mapSizeY);

  for (int x=0; x<mapSizeX; x++)
    for (int y=0; y<mapSizeY; y++)
      fin >> slamMap(x,y);

  fin.close();

  return 1;
}

int RobotController::readRobotPoseFromFile(string fileName)
{
  ifstream fin(fileName.c_str());

  if (!fin)
    {
      cout << "Could not read pose data from file:" << fileName << endl;
      return 0;
    }

  fin >> currentRobotPose.x >> currentRobotPose.y >> currentRobotPose.t;

  fin.close();

  return 1;
}


int RobotController::readLaserScanFromFile(string fileName, vector<float> &lsd) 
{
    int count;

    ifstream fin(fileName.c_str());

    if (!fin.is_open())
      {
	cout << "Could not read laser scan data from file:" << fileName << endl;
	return 0;
      }

    fin >> count; 

    lsd.clear();
    lsd.reserve(count);

    for(int i=0; i<count; i++)
      fin>>lsd[i];
    
    fin.close();

    remove(fileName.c_str());
    
    return count;	
}



